; Csound orchestra for use with cloudMain.py
; Oeyvind Brandtsegg 2006, obrandts@online.no



	sr	=	44100
	ksmps	=	128
	nchnls	=	2
	0dbfs = 32768

	giDenorm	init 0.00000000000000001

; live sampling ftables
	giLiveSamplTableLen 	init 16777216
	giLiveSamplAudioTable	ftgen	0, 0, giLiveSamplTableLen, 2, 0	; empty table, size 16777216 equals 380 seconds at 44.1kHz sr
	giLiveSamplAttackTable	ftgen	0, 0, 131072, 2, 0	; empty table, size = maximum number of audio segments 
; init table write position for live sampling
	gkstart		init 0
	gkAtckIndex 	init 0
	gkNumSegments	init 0

#include "inc/ftables_classic.inc"
#include "inc/ftables_envelopes.inc"
#include "inc/ftables_samples.inc"
#include "inc/ftables_masks.inc"
#include "inc/macro_partikkel_instr_cloud.inc"
#include "inc/globals_chnset.inc"
#include "inc/globals_macros.inc"


;****************************************************************
	instr 5
turnoff		; i-time only
#include "inc/loadPartikkelSamples.inc"
	endin

instr 101
#include "inc/cloudSegmentAutomation.inc"
;#include "inc/cloudSegmentControl.inc" ; old, redundant
endin

instr 102
#include "inc/cloudParameterMapping.inc"

endin


instr 103

$PartikkelInstrCloud(1)
$PartikkelInstrCloud(2)
$PartikkelInstrCloud(3)
$PartikkelInstrCloud(4)

#include "inc/partikkel_out_efx.inc"

endin


; rewrite channel masks
	instr 105
#include "inc/rewriteChannelMasks.inc"
	endin


; effects, instr 300 and up
#include "inc/channelEffects.inc"

; global audio out
#include "inc/global_audio_out.inc"

