
; channel names set via p-fields
	iStart		= p4		; start value
	iCurve		= p5		; curvature value
	iEnd		= p6		; end value
	Schn		strget	p7	; output chn 
	imap		= p8		; mapping code, for realtime modification of cloud automation
					; all 'rDev' channels have	imap = 1
					; All 'Amp' channels have 	imap = 2
					; all 'GrRate' channels have 	imap = 3
					; all 'Transp' channels have	imap = 4
					; all 'Dur' channels hvae	imap = 5
					; 'grDist' channel have		imap = 6
					; 'rMask' channels have		imap = 7
					; 'chanMask' channels have	imap = 8

; cloud control automation, one instance per parameter

	kParm	     	transeg	iStart, p3, iCurve, iEnd

; make sure end value is reached
	ktime		timeinsts
	kParm		= (ktime >= p3-1/kr ? iEnd : kParm)

; mapping for realtime control of cloud
	kTranspScale	chnget "TranspScale"
	kRateScale	chnget "RateScale"
	kTurbulence	chnget "Turbulence"
	kTurbulence	limit	kTurbulence, 0, 2			; limit value to avoid mapping formulas to blow up
	kTransparency	chnget "Transparency"
	kTransparency	limit	kTransparency, -1, 1			; limit value to avoid mapping formulas to blow up
		
	cggoto (imap == 3), grainrate
	cggoto (imap == 4), transposition
	cggoto (imap == 1), randomDeviation
	cggoto (imap == 5), graindur
	cggoto (imap == 6), grDist
	cggoto (imap == 7), rMask
	cggoto (imap == 8), chanMask
	goto setChan

grainrate:
	kParm = (kParm * kRateScale) 					; grain rate scaling
	kParm = kParm - (kParm * kTransparency * 0.8) 			; transparency mapping
	kParm limit kParm, 0.01, 10000					; safety, prevents negative values
	goto setChan

transposition:
	kParm = (kParm * kTranspScale)					; grain transposition scaling		
	kParm limit kParm, 0.01, 30					; safety, prevents negative values and way too high transposition
	goto setChan

graindur:
	kTransparencyPow	pow 	kTransparency, 0.5		; convex curve mapping of transparency value
	kParm = kParm - (kParm * kTransparency * 0.98) 			; transparency mapping
	goto setChan

rMask:
	kParm = kParm + (kTransparency * 0.4) 			; transparency mapping
	kParm 	= (kTurbulence > 1 ? kParm + ((kTurbulence-1)*0.2) : kParm * kTurbulence) ; turbulence mapping
	kParm	limit kParm, 0, 0.91
	goto setChan

grDist:
;	kParm = kParm + (kTransparency * 0.3) 			; transparency mapping, grDist seems to make more grains ? do not make transparent
	kParm 	= (kTurbulence > 1 ? kParm + ((kTurbulence-1)*0.2) : kParm * kTurbulence) ; turbulence mapping
	kParm	limit kParm, 0, 0.95
	goto setChan

randomDeviation:
	kParm 	= (kTurbulence > 1 ? kParm + (kTurbulence-1) : kParm * kTurbulence) ; turbulence mapping
	S1		strcpy	"noisFmIndxRdev"
	S2		strcpy	"fmIndxRdev"
	iEqual1		strcmp	Schn, S1
	iEqual2		strcmp	Schn, S1
	iDoLimit	= (iEqual1 == 1 || iEqual2 == 1 ? 0 : 1)	; select parameters for which to bypass limiting
	cggoto (iDoLimit == 0), noRdevLimit		; do not use limit on selected parameters
	kParm	limit kParm, 0, 1
noRdevLimit:
	goto setChan

chanMask:
	; ftmorf from one channel mask table to another
	ftmorf	kParm, giChnMorf, giChnMaskCloud
	goto end

;noMapping:
;	puts Schn, 1
;	puts " cloudSegmentControl.inc parameter has no mapping", 1
;	goto end

setChan:
	chnset		kParm, 	Schn
end:	

