;   Copyright 2006 yvind Brandtsegg

;   All contributors can be found in credit.txt file

;   This file is part of ImproSculpt.

;   ImproSculpt is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation; either version 2 of the License, or
;   (at your option) any later version.

;   ImproSculpt is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.

;   You should have received a copy of the GNU General Public License
;   along with ImproSculpt in the GeneralPublicLicense.txt file;
;   if not, write to the Free Software Foundation, 
;   Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

; delay effect
; ain is input, aLeft and aRight are outputs

; line1 delay time X4
; line2 delay time X3, offset with delay time X2
; line3 delay time X7
; line 3 feed back to input
; line 1&2 feed back to self

; controls: time, feed
kFeedback	= 0.2
aDelTime	= 250 ; delay time in milliseconds for vdelay
imaxdel1	= 5000
imaxdel2	= 3000
imaxdel3	= 7000
imaxdelO	= 2000

; input, the signal ain is considered an excisting input signal to this module
ain1		init	0
ain2		init	0
ain3		init	0

ain		= ain + ain3
ain1		= ain + ain1
ainOffset	vdelay	ain, aDelTime*2, imaxdelO
ain2		= ainOffset + ain2

; delay processing
aDly1		vdelay	ain1, aDelTime*5, imaxdel1
aDly2		vdelay	ain2, aDelTime*3, imaxdel2
aDly3		vdelay	ain3, aDelTime*7, imaxdel3

; feedback
ain1		= aDly1 * kFeedback * 0.75
ain2		= aDly2 * kFeedback
ain3		= (aDly3 * kFeedback * 0.4) ; +(ain1 + ain2) 

; auto pan of delay line 3
kpan		oscil	0.3, 0.15, giTri
aDly3L		= aDly3 * kpan
aDly3R		= aDly3 * (1-kpan)

aLeft	= aDly1 + aDly3L
aRight 	= aDly2 + aDly3R

