#!/usr/bin/python
# -*- coding: latin-1 -*-
"""
Partikkel Cloud Designer.
A gui for composing 4-voice partikkel cloud automation data.

This is the main file,
all it does is to set up and instantiate all other modules.

@author: yvind Brandtsegg
@contact: obrandts@gmail.com
@license: GPL
@requires: wxWidgets for Python
@requires: csnd
"""

import wx
from cs.csMessages import *
from cs.csoundModule import *
import cloudGui
import playControls
import eventCaller

import csnd
csound = csnd.CppSound()
"""Create an instance of the CppSound class."""
csound.setPythonMessageCallback()
"""Enables Python message callback from Csound."""
import csoundCommandLine
csoundCommandLine = csoundCommandLine.csoundCommandLine
"""Read the parameters for the csound command line from file csoundCommandLine.py"""
csThread = CsoundThread(csound, csoundCommandLine)
"""Create the Csound thread."""
csMessages = CsoundMessages(csound)
"""Create an instance of cs messages"""
eventCaller = eventCaller.EventCaller(csMessages)
"""Create an instance of the eventCaller"""

#--------------------------------------------------------------------------------

# Main body of app

ctrl_app = wx.PySimpleApp()
playControlsFrame = playControls.PlayControls(None, eventCaller)
"""Create an instance of the playControls Gui frame."""
eventCaller.guiPlayControls = playControlsFrame
"""Pointer to the playControls GUI frame instance inside the eventCaller module."""
playControlsFrame.Show(True)

# init values and start the various threads
eventCaller.initValues1()
csThread.start()
eventCaller.initValues2()
eventCaller.theTimeSeconds.start()

ctrl_app.MainLoop()
# stop threads
eventCaller.theTimeSeconds.stop()
csThread.stop()

# End of main body

